#include <stdio.h>
#include <stdlib.h>

#include <gsloop.h>
#include <gsloop_types.h>

#define STR(x)	#x

#define so(_var)	\
fprintf(stdout, "sizeof(%s): %d\n", STR(_var), sizeof(_var));

#define size_test(_var)					\
fprintf(stdout,						\
	"sizeof(%s): %d, "	"sizeof(%s): %d, ",	\
	"struct "STR(_var),	sizeof(struct _var),	\
	STR(_var)"_t",		sizeof(_var##_t)	\
	);						\
if (sizeof(struct _var) != sizeof(_var##_t)) {		\
	fprintf(stdout, "FAIL\n");			\
	exit (EXIT_FAILURE);				\
} else							\
	fprintf(stdout, "PASS\n")

int main(int argc, char *argv[])
{
	size_test(gsloop);
	size_test(gsloop_server);
	size_test(gsloop_client);
	size_test(gsloop_common);

	exit(EXIT_SUCCESS);
}
